{#-#####################################################################
 # Jinja2 template for /etc/rc.conf.d/netif
 #======================================================================
 # Helper macros for the FreeBSD rc network framework
 ####################################################################-#}
{#======================================================================
 # Render cloned interfaces
 #----------------------------------------------------------------------
 # This macro generates and echoes the 'cloned_interfaces' rc variable.
 #
 # Parameters:
 #    - indexes (dict) Interface indexes built by the main.j2 template
 #
 # Note that we use the ``cloned_interfaces`` variable to create 'vlan'
 # interfaces instead of ``vlans_x`` variables because it's far easier
 # to handle in Jinja (``vlans_x`` require that we build the full list
 # of all child vLANs for each interface, which is quite tedious).
 #===================================================================-#}
{%- macro render_cloned_interfaces(indexes) -%}
  {%- set cloned_interfaces = [] -%}

  {%- for uid,interface in indexes['valid_interfaces'].items() -%}
    {%- if interface['type'] in ['bond', 'bridge', 'vlan'] -%}
      {%- set native_device_name =
        config.get_device_name_from_interface(
          interface,
          indexes,
          true) -%}
      {%- if interface['enabled'] is sameas true -%}
        {{ cloned_interfaces.append(native_device_name) }}
      {%- endif -%}
    {%- endif -%}
  {%- endfor -%}

  {%- if cloned_interfaces -%}
    {{ helpers.format_rc_var(
      'cloned_interfaces',
      cloned_interfaces | join(" "))
    }}
  {%- endif -%}
{%- endmacro -%}

{#======================================================================
 # Render create_args_x
 #----------------------------------------------------------------------
 # This macro generates and echoes the 'create_args_x' rc variable for
 # the supplied virtual interface.
 #
 # Parameters:
 #    - interface (dict) An interface definition
 #    - indexes   (dict) Interface indexes built by the main.j2 template
 #===================================================================-#}
{%- macro render_create_args_x(interface, indexes) -%}
  {%- set args = [] -%}
  {%- set native_device_name =
    config.get_device_name_from_interface(
      interface,
      indexes,
      true) -%}

  {#--------------------------------------------------------------------
   # Bond interfaces
   #------------------------------------------------------------------#}
  {%- if interface['type'] == 'bond' -%}
    {#- Bond mode -#}
    {%- set bond_mode =
        config.get_bond_native_mode(interface['bond']['mode']) -%}
    {%- if bond_mode -%}
      {{ args.append('laggproto ' ~ bond_mode) }}
    {%- endif -%}

    {#- Bond hash policy -#}
    {%- set bond_hash_policy =
        config.get_bond_native_hash_policy(
          interface['bond']['mode'],
          interface['bond']['hash_policy']
        )
    -%}
    {%- if bond_hash_policy -%}
      {{ args.append('lagghash ' ~ bond_hash_policy) }}
    {%- endif -%}

    {#- Bond slaves -#}
    {%- set bond_slaves_native_device_names =
        config.get_device_names_from_interface_uids(
          interface['bond']['slaves'],
          indexes,
          true) | from_json -%}
    {%- for device_name in bond_slaves_native_device_names -%}
      {{ args.append('laggport ' ~ device_name) }}
    {%- endfor -%}

  {#--------------------------------------------------------------------
   # Bridge interfaces
   #------------------------------------------------------------------#}
  {%- elif interface['type'] == 'bridge' -%}

    {#- Shortcut variables -#}
    {%- set bridge_stp = interface['bridge']['stp'] -%}

    {#- Bridge members -#}
    {%- set bridge_members_native_device_names =
        config.get_device_names_from_interface_uids(
          interface['bridge']['members'],
          indexes,
          true) | from_json -%}
    {%- for device_name in bridge_members_native_device_names -%}
      {{ args.append('addm ' ~ device_name) }}
      {#- Per-member STP options -#}
      {%-   if bridge_stp['enabled'] is sameas true -%}
        {{ args.append('stp') }}
      {%- elif bridge_stp['enabled'] is sameas false -%}
        {{ args.append('-stp') }}
      {%- endif -%}
    {%- endfor -%}

    {#- Bridge-wide STP options -#}
    {%- if bridge_stp['enabled'] is sameas true -%}
      {%- if bridge_stp['fwd_delay'] is not sameas None -%}
        {{ args.append('fwddelay ' ~ bridge_stp['fwd_delay'] | int) }}
      {%- endif -%}
      {%- if bridge_stp['hello_time'] is not sameas None -%}
        {{ args.append('hellotime ' ~ bridge_stp['hello_time'] | int) }}
      {%- endif -%}
      {%- if bridge_stp['priority'] is not sameas None -%}
        {{ args.append('priority ' ~ bridge_stp['priority'] | int) }}
      {%- endif -%}
      {%- if bridge_stp['variant'] == "classic" -%}
        {{ args.append('proto stp') }}
      {%- elif bridge_stp['variant'] == "rapid" -%}
        {{ args.append('proto rstp') }}
      {%- endif -%}
    {%- endif -%}

  {#--------------------------------------------------------------------
   # vLAN interfaces
   #------------------------------------------------------------------#}
  {%- elif interface['type'] == 'vlan' -%}
    {#- vLAN ID -#}
    {{ args.append('vlan ' ~ interface['vlan']['index'] | int) }}

    {#- vLAN parent device -#}
    {%- set vlan_parent_native_device_name =
        config.get_device_name_from_interface_uid(
          interface['vlan']['parent'],
          indexes,
          true) -%}
    {{ args.append('vlandev ' ~ vlan_parent_native_device_name) }}
  {%- endif -%}

  {%- if args and interface['enabled'] is sameas true -%}
    {{
      helpers.format_rc_var(
        'create_args_' ~ native_device_name,
        args | join(" ")
      )
    }}
  {%- endif -%}
{%- endmacro -%}

{#======================================================================
 # Render ifconfig_x variable
 #----------------------------------------------------------------------
 # This macro is responsible for generating and echoing the main
 # ifconfig_x rc variable for the supplied interface.
 #
 # Parameters:
 #    - interface (dict) An interface definition
 #    - indexes   (dict) Interface indexes built by the main.j2 template
 #===================================================================-#}
{%- macro render_ifconfig_x(interface, indexes) -%}
  {#- ifconfig segments are stored in this buffer list -#}
  {%- set segments = [] -%}
  {%- set device =
    config.get_device_name_from_interface(interface, indexes) -%}

  {#- ifconfig keywords must come before anything else -#}
  {%- set keywords =
      ifconfig.get_keywords(interface, indexes) | from_json -%}
  {%- if keywords -%}
    {{ segments.append(keywords | join(" ")) }}
  {%- endif -%}

  {#- ifconfig link options must come before static inet4 addressing -#}
  {%- set link_options =
      ifconfig.get_link_options(interface, indexes) | from_json -%}
  {%- if link_options -%}
    {{ segments.append("link " ~ link_options | join(" ")) }}
  {%- endif -%}

  {#- ifconfig inet options must come after link options -#}
  {%- set inet_options =
      ifconfig.get_inet_options(interface, indexes) | from_json -%}
  {%- if inet_options -%}
    {{ segments.append("inet " ~ inet_options | join(" ")) }}
  {%- endif -%}

  {#- ifconfig interface options must come at the very end -#}
  {%- set interface_options =
      ifconfig.get_interface_options(interface, indexes) | from_json -%}
  {%- if interface_options -%}
    {{ segments.append(interface_options | join(" ")) }}
  {%- endif -%}

  {#- Render the rc variable line -#}
  {%- set rc_var_name = "ifconfig_" ~ device -%}
  {%- set rc_var_value = segments | join(" ") -%}
  {%- if rc_var_value -%}
    {{ helpers.format_rc_var(rc_var_name, rc_var_value) }}
  {%- endif -%}
{%- endmacro -%}

{#======================================================================
 # Render ifconfig_x_inet6 variable
 #----------------------------------------------------------------------
 # This macro is responsible for generating and echoing the
 # ifconfig_x_inet6 rc variable for the supplied interface.
 #
 # Parameters:
 #    - interface (dict) An interface definition
 #    - indexes   (dict) Interface indexes built by the main.j2 template
 #===================================================================-#}
{%- macro render_ifconfig_x_inet6(interface, indexes) -%}
  {#- ifconfig segments are stored in this buffer list -#}
  {%- set segments = [] -%}
  {%- set device =
    config.get_device_name_from_interface(interface, indexes) -%}

  {#- ifconfig inet6 options -#}
  {%- set inet6_options =
      ifconfig.get_inet6_options(interface, indexes) | from_json -%}
  {%- if inet6_options -%}
    {{ segments.append("inet6 " ~ inet6_options | join(" ")) }}
  {%- endif -%}

  {#- Render the rc variable line -#}
  {%- set rc_var_name = "ifconfig_" ~ device ~ '_ipv6' -%}
  {%- set rc_var_value = segments | join(" ") -%}
  {%- if rc_var_value and interface['enabled'] is sameas true -%}
    {{ helpers.format_rc_var(rc_var_name, rc_var_value) }}
  {%- endif -%}
{%- endmacro -%}

{#======================================================================
 # Render ifconfig_x_aliases line
 #----------------------------------------------------------------------
 # This macro is responsible for generating and echoing the
 # ifconfig_x_aliases rc variable for the supplied interface.
 #
 # Parameters:
 #    - interface (dict) An interface definition
 #    - indexes   (dict) Interface indexes built by the main.j2 template
 #===================================================================-#}
{%- macro render_ifconfig_x_aliases(interface, indexes) -%}
  {#- ifconfig segments are stored in this buffer list -#}
  {%- set aliases = [] -%}
  {%- set device =
      config.get_device_name_from_interface(interface, indexes)-%}

  {#- Set shortcut variables -#}
  {%- set inet4   = interface['inet4'] -%}
  {%- set inet6   = interface['inet6'] -%}
  {%- set static4 = interface['inet4']['static'] -%}
  {%- set static6 = interface['inet6']['static'] -%}
  {%- set options4 =
      role__sys_net_interfaces__framework_options[
        'options']['inet4']['aliases']-%}
  {%- set options6 =
      role__sys_net_interfaces__framework_options[
        'options']['inet6']['aliases']-%}

  {#--------------------------------------------------------------------
   # IPv4 aliases
   #------------------------------------------------------------------#}
  {#- If IPv4 is explicitly disabled, skip IPv4 alias generation! -#}
  {%- if inet4['enabled'] is not sameas false -%}
    {#- We only define aliases when the number of assigned static
     #  addresses is greater than 1 -#}
    {%- if static4 | length > 1 -%}
      {#- We need to store the subnet of the main IPv4 address to
       #  to use non-conflicting subnets for aliases in the same
       #  subnet. The main address is then ignored. -#}
      {%- set main_address_def = None -%}
      {%- if options4['use_non_conflicting_netmasks'] == true -%}
        {%- set main_address_def = static4[0] -%}
      {%- endif -%}

      {#- Enumerate aliases -#}
      {%- for address_def in static4 -%}
        {#- Only process aliases; ignore main address -#}
        {%- if loop.index > 1 -%}
          {%- set address =
            helpers.format_inet_address(
              address_def,
              main_address_def) -%}
          {%- if address -%}
            {{ aliases.append("inet " ~ address) }}
          {%- endif -%}
        {%- endif -%}
      {%- endfor -%}
    {%- endif -%}
  {%- endif -%}

  {#--------------------------------------------------------------------
   # IPv6 aliases
   #------------------------------------------------------------------#}
  {#- If IPv6 is explicitly disabled, skip IPv6 alias generation! -#}
  {%- if inet6['enabled'] is not sameas false -%}
    {#- We only define aliases when the number of assigned static
     #  addresses is greater than 1 -#}
    {%- if static6 | length > 1 -%}

      {#- Non-conflicting netmasks are not required for IPv6 aliases
       #  but may be enabled anyway. -#}
      {%- set main_address_def = None -%}
      {%- if options6['use_non_conflicting_netmasks'] == true -%}
        {%- set main_address_def = static6[0] -%}
      {%- endif -%}

      {#- Enumerate aliases -#}
      {%- for address_def in static6 -%}
        {#- Only process aliases; ignore main address -#}
        {%- if loop.index > 1 -%}
          {%- set address =
            helpers.format_inet6_address(
              address_def,
              main_address_def) -%}
          {%- if address -%}
            {{ aliases.append("inet6 " ~ address) }}
          {%- endif -%}
        {%- endif -%}
      {%- endfor -%}
    {%- endif -%}
  {%- endif -%}

  {#- Render the rc variable line -#}
  {%- set rc_var_name = "ifconfig_" ~ device ~ '_aliases' -%}
  {%- set rc_var_value = aliases -%}
  {%- if aliases and interface['enabled'] is sameas true -%}
    {{ helpers.format_rc_var(rc_var_name, rc_var_value) }}
  {%- endif -%}
{%- endmacro -%}

{#======================================================================
 # Render ifconfig_x_descr variable
 #----------------------------------------------------------------------
 # This macro is responsible for generating and echoing a single
 # ifconfig_x_descr rc variable for the supplied interface. The variable
 # shall only be echoed if the interface includes a description.
 #
 # Parameters:
 #    - interface (dict) An interface definition
 #    - indexes   (dict) Interface indexes built by the main.j2 template
 #===================================================================-#}
{%- macro render_ifconfig_x_descr(interface, indexes) -%}
  {%- set device =
    config.get_device_name_from_interface(interface, indexes) -%}

  {%- if interface['desc'] and interface['enabled'] is sameas true -%}
    {%- set rc_var_name = "ifconfig_" ~ device ~ "_descr" -%}
    {#- [0:126] => 127 chars + null! -#}
    {%- set rc_var_value = interface['desc'][0:126] -%}
    {{ helpers.format_rc_var(rc_var_name, rc_var_value) }}
  {%- endif -%}
{%- endmacro -%}

{#======================================================================
 # Render ifconfig_x_name variable
 #----------------------------------------------------------------------
 # This macro is responsible for generating and echoing a single
 # ifconfig_x_name rc variable for the supplied interface. The variable
 # shall only be echoed if the interface is eligible to interface
 # renaming.
 #
 # Parameters:
 #    - interface (dict) An interface definition
 #    - indexes   (dict) Interface indexes built by the main.j2 template
 #===================================================================-#}
{%- macro render_ifconfig_x_name(interface, indexes) -%}
  {%- set native_device_name =
    config.get_device_name_from_interface(interface, indexes, true) -%}
  {%- set final_device_name =
    config.get_device_name_from_interface(interface, indexes, false)-%}

  {%- if final_device_name != native_device_name -%}
    {%- set rc_var_name = "ifconfig_" ~ native_device_name ~ "_name" -%}
    {%- set rc_var_value = final_device_name -%}
    {{ helpers.format_rc_var(rc_var_name, rc_var_value) }}
  {%- endif -%}
{%- endmacro -%}

{#======================================================================
 # Render ipv6_cpe_wanif variable
 #----------------------------------------------------------------------
 # This macro generates and echoes the 'ipv6_cpe_wanif' rc variable,
 # which configures network interfaces to accept router advertisement
 # messages whereas inet6 forwarding is enabled.
 #
 # Parameters:
 #    - indexes (dict) Interface indexes built by the main.j2 template
 #===================================================================-#}
{%- macro render_ipv6_cpe_wanif(indexes) -%}
  {%- set devices = []-%}

  {%- for uid,interface in indexes['valid_interfaces'].items() -%}
    {%- if  interface['enabled'] is sameas true
        and interface['type'] == 'bond'
        and interface['bond']['ndp']['rtadv']['enabled'] is sameas true
        and interface['bond']['ndp']['rtadv']['forced'] is sameas true
    -%}
      {{
        devices.append(
          config.get_device_name_from_interface(
            interface,
            indexes
          )
        )
      }}
    {%- endif -%}
  {%- endfor -%}

  {%- if devices -%}
    {%- set rc_var_name = "ipv6_cpe_wanif" -%}
    {%- set rc_var_value = devices | join(" ") -%}
    {{ helpers.format_rc_var(rc_var_name, rc_var_value) }}
  {%- endif -%}
{%- endmacro -%}
